--Engraved Invitation
--20090818
--Author MMoose

Ei = LibStub("AceAddon-3.0"):NewAddon("Ei", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0")
local addon = Ei
--options array here

local function giveEiOptions()
	command_options = {
		type = "group",
		name = "Ei",
		args = {
			header1 =
			{
				order = 5,
				type = "header",
				name = "",
			},
			version =
			{
				order = 5,
				type = "description",
				name = "Ei\n";
			},
		}
	}
	return command_options
end

local function giveOptionsEi()
	local options = { 
		type = "group",
		args = {
			General = {
			type = 'group',
			name = "General",
			desc = "General",
				args = {
					showmmButton = {
						name = EiLOC["mmbutton"],
						desc = EiLOC["mmbuttondesc"],
				        type = "toggle",
						width = "double",
						get	= function() return addon.db.profile.usemm end,
						set	= function() addon.db.profile.usemm = not addon.db.profile.usemm Ei:mmButton_toggle() end,
						order = 16,				
		            }, 
					mmButtonAngle = {
						name = EiLOC["mmbuttonangle"],
						desc = EiLOC["mmbuttonangledesc"],
				        type = "range",
						set = function(info, value) addon.db.profile.MiniMapPos = value Ei.mmButton_reposition() end,
		                get = function() return addon.db.profile.MiniMapPos end,
				        min = 0,
						max = 360,
		                step = 0.01,
						order = 17,                
		            },	
		            mmButtonRad = {
						name = EiLOC["mmbuttonrad"],
						desc = EiLOC["mmbuttonraddesc"],
						type = "range",
		                set = function(info, value) addon.db.profile.MiniMapRad = value Ei.mmButton_reposition() end,
				        get = function() return addon.db.profile.MiniMapRad end,
						min = 20,
		                max = 200,
				        step = 0.01,
						order = 18,                
		            }, 		
				},
			},		
			istrings = {
			type = 'group',
			name = EiLOC["istrings"],
			desc = EiLOC["istrings"],
				args = {
					isubj = {
						name = EiLOC["isubj"],
						desc = EiLOC["isubjdesc"],
						type = "input",
						width = "double",
						--multiline = true,
						set = function(info, value) addon.db.profile.isubjdef = value end,
						get = function() return addon.db.profile.isubjdef end,
						order = 7,			
		            }, 
					itext = {
						name = EiLOC["itext"],
						desc = EiLOC["itextdesc"],
						type = "input",
						width = "double",
						multiline = true,
						set = function(info, value) addon.db.profile.itextdef = value end,
						get = function() return addon.db.profile.itextdef end,
						order = 8,			
		            }, 		     
		            iappend = {
						name = EiLOC["iappend"],
						desc = EiLOC["iappendd"],
						type = "toggle",
						width = "double",
						get = function() return addon.db.profile.iappend end,
						set = function() addon.db.profile.iappend = not addon.db.profile.iappend end,
						order = 9,
					},
					iappendt = {
						name = EiLOC["iappendt"],
						desc = EiLOC["iappendtd"],
						type = "input",
						width = "double",
						set = function(info, value) addon.db.profile.iappendt = value end,
						get = function() return addon.db.profile.iappendt end,
						order = 10,
					},
				},
			},				
		}
    }  
    return options
end
--init functions here
function Ei:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("EiDB", defaults)
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Ei",giveOptionsEi)

	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	self.optionsFrames = {}
	self.optionsFrames.Ei = AceConfigDialog:AddToBlizOptions("Ei",EiLOC["longVersionString"], nil, "General")
	self.optionsFrames.RollDefs = AceConfigDialog:AddToBlizOptions("Ei",EiLOC["istrings"], EiLOC["longVersionString"], "istrings")	

    self.db:RegisterDefaults(
		{ 
			profile =
			{
				MiniMapPos = 320,
				MiniMapRad = 80,
				usemm = true,
				isubjdef = EiLOC["isubjdef"],
				itextdef = EiLOC["itextdef"],
				iappend = EiLOC["iappendtext"],
				iappendt = EiLOC["checkcal"],
			}
		}
	)
	Ei.invdta = {}
	Ei.recv = ""
	Ei.msg = ""
	Ei.ind = 0
	Ei.good = false
	Ei.working = false
	Ei.invprepared = false
	Ei:RegisterEvent("PLAYER_ENTERING_WORLD")
	Ei:RegisterEvent("CALENDAR_OPEN_EVENT")
	Ei:RegisterEvent("MAIL_SHOW")
	Ei:RegisterEvent("MAIL_SEND_SUCCESS")
	Ei:RegisterEvent("MAIL_FAILED")
	
	--register the day names here
	--let the client handle localization
	Ei.dys = {}

end

